import java.awt.BorderLayout;
import java.awt.event.*;

import javax.swing.*;

/*
 * Created on 7 fvr. 2006
 */

/**
 * @author Emmanuel DURIN
 *
 */
public class Main {

    public static void main(String[] args) {
        
        final SortableListModel model = new SortableListModel();
        model.addElement("Haddock");
        model.addElement("Tintin");
        model.addElement("Dupond");
        model.addElement("Dupont");
        for (int i =0; i<26; i++)
            model.addElement( "" + (char)('a'+i) );
        JFrame jf = new JFrame("Listbox demo");
        jf.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        final JList list = new JList(model);
        final JTextField textField = new JTextField(15);
        jf.getContentPane().add(textField, BorderLayout.NORTH);
        JScrollPane jsp = new JScrollPane(list);
        jf.getContentPane().add( jsp, BorderLayout.CENTER);

        final JScrollBar scrollBar = jsp.getVerticalScrollBar();
                
        textField.addKeyListener(new KeyAdapter(){
            public void keyTyped(KeyEvent e) {
                if ( e.getKeyChar() == KeyEvent.VK_ENTER){
                    // l'utilisateur a tap sur Entre
                    // faire l'insertion au bon point :
                    // le modle s'en charge
                    model.addElement(textField.getText());
                    textField.setText("");
                }else{
                    // L'utilisateur a saisi un caractre qui n'est pas Entre
                    // Il s'agit de faire dfiler la Scrollbar jusqu'au mot le plus proche
                    int count = model.getSize();
                    if ( count == 0 )
                        return;
                    int i= 0;
                    String text = textField.getText()  + e.getKeyChar();
                    for( ; i < model.getSize(); i++){
                        if ( text.compareToIgnoreCase( (String)model.getElementAt(i)) <= 0){
                            if (i>0)
                                i--;
                            break;
                        }
                    }
                    int x = (i*scrollBar.getMaximum())/( count -1 ) ;
                    scrollBar.setValue(x);
                }
            }
        });
        jf.pack();
        jf.setVisible(true);
    }
}