import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.tree.*;

class CheckBoxRenderer
    extends JCheckBox
    implements TreeCellRenderer
{
    DefaultTreeCellRenderer _defaultRenderer =
        new DefaultTreeCellRenderer();

    Color _selectionColor = new Color(200, 200, 255);
    
    CheckBoxRenderer(JTree tree)
    {
        setFont(tree.getFont());
        setBorder(new LineBorder(new Color(150,150,255), 1));
        setHorizontalAlignment(JCheckBox.CENTER);
        addItemListener( new ItemListener()
                {

                    public void itemStateChanged(ItemEvent e) {
                       System.out.println("click");
                    }
                
                });
    }
    public Component getTreeCellRendererComponent (
            JTree tree, Object value, boolean isSelected,
            boolean expanded, boolean leaf, int row, boolean hasFocus)
            {
                if (leaf)
                {
                    setBorderPainted(isSelected);
                    setFocusPainted(hasFocus);

                    if (isSelected) setBackground(_selectionColor);
                    else setBackground(tree.getBackground());
            
                    setText(value.toString());
                    setSelected(((CheckNode)value).getCheckState());

                    return this;
                }
                else    return _defaultRenderer.getTreeCellRendererComponent (
                tree, value, isSelected, expanded, leaf, row, hasFocus);
            }
        }
