import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;

public class CheckBoxTreeExample extends JFrame
{
    JTree _tree;
    DefaultTreeModel _model;
    
    public CheckBoxTreeExample() {
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Options");
        DefaultMutableTreeNode indent = new DefaultMutableTreeNode("Indent Options");
        DefaultMutableTreeNode save = new DefaultMutableTreeNode("Save Options");

        root.add(indent);
        root.add(save);

        indent.add(new CheckNode("Smart indent"));
        indent.add(new CheckNode("Indent after brace"));
        indent.add(new CheckNode("Use tab character"));

        save.add(new CheckNode("Create backup file"));
        save.add(new CheckNode("Strip trailing whitespaces"));
        _model = new DefaultTreeModel(root, true);
        _tree = new JTree(_model);
        _tree.setEditable(false);
        _tree.setCellRenderer(new CheckBoxRenderer(_tree));
        //_tree.addMouseListener(new ToggleHandler());
        
        getContentPane().add(new JScrollPane(_tree));
        setSize(300,300);
    }
    
    public static void main (String[] args)
    {
        CheckBoxTreeExample example =
        new CheckBoxTreeExample();

        example.setVisible(true);
    }
    class ToggleHandler extends MouseAdapter
    {       
        public void mousePressed(MouseEvent evt)
        {
            TreePath path = _tree.getPathForLocation(evt.getX(), evt.getY());

            if (path != null)
            {
                TreeNode node =  (TreeNode) path.getLastPathComponent();

                 if (node instanceof CheckNode)
                 {
                     ((CheckNode)node).toggle();
                     _model.nodeChanged(node);
                 }
            }
        }
    }
}
