/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.io.*;
import java.io.File;

import javax.swing.*;
import javax.swing.AbstractAction;

import jgui.gui.ContactsApplet;
import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class OpenAction extends AbstractAction {

    private ContactsModel model;

    private JLabel statusBar;

	private ContactsApplet applet;
    public OpenAction(ContactsApplet applet, JLabel statusBar, ContactsModel model) {
        this.model = model;
        this.applet = applet;
        this.statusBar = statusBar;
        putValue(SHORT_DESCRIPTION, "Open file");
        putValue(LONG_DESCRIPTION, "Open a user selected file.");
        putValue(NAME, "Open...");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "open.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_O) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
    }
    
    public void actionPerformed(ActionEvent event) {
        if ( model.isDirty() ){
	        int result = JOptionPane.showConfirmDialog(applet, "Do you want to save your changes before opening another file ?","Caution",JOptionPane.YES_NO_CANCEL_OPTION);
	        switch ( result ){
	        	case JOptionPane.YES_OPTION:
	        	    if (model.getFile() == null){
	        			JFileChooser saveDialog = new JFileChooser();
	        			if ( saveDialog .showSaveDialog(applet) == JFileChooser.APPROVE_OPTION){
	        			    model.setFile( saveDialog .getSelectedFile());
	        			}
	        	    }
	//                	    Check the user has selected a file
	        	    if ( model.getFile() != null )
                        try {
                            model.save();
                        } catch (IOException e1) {
                            e1.printStackTrace();
                        }                	    
	        	    break;
	        	case JOptionPane.NO_OPTION:
	        	    // nothing to do here
	        	    break;
	        	case JOptionPane.CANCEL_OPTION:
	        	    return ;                	
	        }
        }
        
		JFileChooser openDialog = new JFileChooser();
		if ( openDialog.showOpenDialog(applet) != JFileChooser.APPROVE_OPTION){
		    return;
		}
	    File selectedFile = openDialog.getSelectedFile();
		statusBar.setText("... ");
		try {
		    model.open( selectedFile  );		    
            statusBar.setText( selectedFile.getCanonicalPath());
        } catch (Exception e) {
            // en  attente de mieux signaler les erreurs            
            e.printStackTrace();
        }
    }
}
