/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.*;
import javax.swing.AbstractAction;

import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class OpenAction extends AbstractAction {

    private ContactsModel model;
    private JFrame frame;
    private JLabel statusBar;
    public OpenAction(JFrame frame, JLabel statusBar, ContactsModel model) {
        this.model = model;
        this.frame = frame;
        this.statusBar = statusBar;
        putValue(SHORT_DESCRIPTION, "Open file");
        putValue(LONG_DESCRIPTION, "Open a user selected file.");
        putValue(NAME, "Open...");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "open.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_O) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_O,
                ActionEvent.CTRL_MASK));
    }
    
    public void actionPerformed(ActionEvent event) {
		JFileChooser jfc = new JFileChooser();
		int result = jfc.showOpenDialog(frame);
		if (result != JFileChooser.APPROVE_OPTION){
		    return;
		}
	    File selectedFile = jfc.getSelectedFile();
		statusBar.setText("... ");
		try {
		    model.open( selectedFile  );		    
            statusBar.setText( selectedFile.getCanonicalPath());
        } catch (Exception e) {
            // en  attente de mieux signaler les erreurs            
            e.printStackTrace();
        }
    }
}
