import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.awt.event.MouseListener;

import javax.swing.*;

/**
 * @author Emmanuel DURIN
 *
 */
public class DrawingFrame extends JFrame implements MouseMotionListener,MouseListener {
    
    private Point startPoint, endPoint;
    public DrawingFrame(String title)
    {
        super(title);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        
        ImageIcon image = new ImageIcon("metal.jpeg");
        JLabel label = new JLabel(image);
        
        getContentPane().add( label);
        addMouseListener(this);
        addMouseMotionListener(this);
        setSize(400,400);        
    }
    
    public static void main(String[] args) {
        JFrame jf = new DrawingFrame("Image/Cursor demo");
        jf.setVisible(true);
    }
    public void mouseClicked(MouseEvent e) { }
    
    public void mouseEntered(MouseEvent e) { }
    public void mouseExited(MouseEvent e) { }
    
    public void mousePressed(MouseEvent e) {
        // efface la prsente slection
        drawSelection();
        startPoint = e.getPoint();
        endPoint = null;
        // fait le dessin du rectangle
        drawSelection();        
    }
    public void mouseReleased(MouseEvent e) {
    }
    
    public void mouseDragged(MouseEvent e) {
        // pour effacer
        drawSelection();
        endPoint = e.getPoint();
        // pour dessiner
        drawSelection();
    }
    public void mouseMoved(MouseEvent e) { }
    /**
     * Cette mthode sert  :
     * 1/ dessiner le rectangle de slection courante
     * 2/ effacer le rectangle de slection courante.
     * Ces deux effets sont raliss par le fait que le dessin 
     * est fait en mode XOR.
     * Le mode XOR a la particularit de revenir au dessin initial lorsque le dessin
     * est effectu 2 fois au mme endroit
     *
     */
    public void drawSelection()
    {
        if (endPoint == null || startPoint == null)
            return;
        Graphics g = getGraphics();
        g.setXORMode(Color.GRAY);
        
        g.drawRect(Math.min(startPoint.x,endPoint.x),
                Math.min(startPoint.y,endPoint.y), 
                Math.abs(endPoint.x-startPoint.x),
                Math.abs(endPoint.y-startPoint.y));    
    }
    /**
     * Dessine la fentre courante avec le bitmap et le rectangle de slection
     */
    public void paint(Graphics g) {
       super.paint(g);
       drawSelection();
    }
}