import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

/**
 * 
 * @author Emmanuel DURIN
 *
 */
public class ContactsFrame extends JFrame {

	// bonne pratique de mettre les composants en attributs
    private JPanel buttonBar ;
    private JButton openButton, saveButton, exitButton;
    private JList contactsList;
    private JLabel statusBar ;
	private DefaultListModel contactsModel;

	public ContactsFrame()  {
		super("Contacts");

		// 1a : Crer la fentre et ses composants
		Container c = getContentPane();
		buttonBar = new JPanel();
		c.add(buttonBar, BorderLayout.NORTH );
		
		openButton = new JButton("open");
		saveButton = new JButton("save");
		exitButton = new JButton("exit");
		
		exitButton.addActionListener( 
	        new ActionListener(){
                public void actionPerformed(ActionEvent event) {
                    dispose();
                    System.exit(0);                    
                }
	        }
		);
		
		
		buttonBar.add(openButton);
		buttonBar.add(saveButton);
		buttonBar.add(exitButton);
		
		c.add(buttonBar, BorderLayout.NORTH );

		contactsModel = new DefaultListModel();
		contactsList = new JList(contactsModel);
		contactsList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );	
		c.add(new JScrollPane(contactsList), BorderLayout.CENTER );
		
		statusBar = new JLabel("File :");
		
		openButton.addActionListener( new OpenListener(statusBar));
		
		c.add(statusBar, BorderLayout.SOUTH );
		setSize(400,300);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        
	}

	
	public static void main(String[] args) {
		ContactsFrame cf = new ContactsFrame();
		cf.setVisible(true);
	}
}
