/*
 * Created on 1 juil. 2005
 */
package myjdbc;

import java.sql.*;

/**
 * @author Emmanuel DURIN
 *
 */
public class Main {
    
    public static void main(String[] args) throws Exception
    {
        // Autre application de l'introspection
        // Charge la classe du driver en mmoire.
        // La classe se charge de s'enregistrer auprs 
        // du DriverManager :
        // elle dclare qu'elle va s'occuper de toutes les 
        // connections du type ODBC
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        
        // 1) l'url commence toujours par jdbc:
        // 2) odbc: indique le type du driver tel qu'il s'est enregistr auprs
        // du DriverManager
        // 3) spcifique au type de driver
        // library est le nom de la source odbc
        Connection c = null;
        ResultSet rs = null;
        Statement request = null;
        try{
            c = DriverManager.getConnection("jdbc:odbc:library");
            request = c.createStatement();
            
            rs = request.executeQuery("SELECT * FROM Document");
            
            while ( rs.next() ){
                String title = rs.getString("Title");
                String author = rs.getString("Author");
                int pages = rs.getInt("Pages");
                //	            Object i = rs.getObject("Pages");
                System.out.println(title + " - " + author + " - " + pages);
            }
        }
        catch( SQLException e )
        {
            //e.getErrorCode()
            // TODO amliorer ce bloc
            e.printStackTrace();
        }
        catch(Exception e ){
            e.printStackTrace();
        }finally{
            if ( rs != null )
                rs.close();
            if ( request != null )
                request.close();
            if (c!=null)
                c.close();
        }
    }
}
