import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.*;

import javax.swing.*;

import jgui.emailer.util.Toolbox;

/**
 *
 * @author Emmanuel DURIN
 *
 */
public class ContactsFrame extends JFrame {

	// bonne pratique de mettre les composants en attributs
    private JPanel buttonBar ;
    private JButton openButton, saveButton, exitButton;
    private JList contactsList;
    private JLabel statusBar ;
	private DefaultListModel contactsModel;
	
	public ContactsFrame()  {
		super("Contacts");

		// 1a : Crer la fentre et ses composants
		Container c = getContentPane();
		buttonBar = new JPanel();
		c.add(buttonBar, BorderLayout.NORTH );
		
		openButton = new JButton("open");
		saveButton = new JButton("save");
		exitButton = new JButton("exit");
		
		buttonBar.add(openButton);
		buttonBar.add(saveButton);
		buttonBar.add(exitButton);
		
		c.add(buttonBar, BorderLayout.NORTH );

		contactsModel = new DefaultListModel();
		////////////////////////////////////////
		contactsList = new JList(contactsModel);
		////////////////////////////////////
//		contactsModel.addListDataListener( contactsList );
		contactsList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );	
		c.add(new JScrollPane(contactsList), BorderLayout.CENTER );
		
		statusBar = new JLabel("File :");
		c.add(statusBar, BorderLayout.SOUTH );
		setSize(400,300);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        
		// 1b : Ajouter les vnements (listeners)
        openButton.addActionListener(
        	new ActionListener(){
        		public void actionPerformed(ActionEvent event)
        		{
        			readFile();
        		}
        });

        exitButton.addActionListener(
            	new ActionListener(){
            		public void actionPerformed(ActionEvent event)
            		{
            			dispose();
            		}
            });
	}

	private void readFile()
	{
		String fileName  = ".." + File.separatorChar + "contacts.data";

		try{
			statusBar.setText("... ");
			Vector v = Toolbox.loadVector( new File( fileName ) );
			statusBar.setText("Finished reading file " + fileName );
			for (Iterator iter = v.iterator(); iter.hasNext();) {
				contactsModel.addElement( iter.next() );
			}	
		}catch( Exception ex ){
			ex.printStackTrace();
		}		
	}
	
	public static void main(String[] args) {
		ContactsFrame cf = new ContactsFrame();
		cf.setVisible(true);
	}
}
