import java.awt.FlowLayout;

import javax.swing.*;

import jgui.emailer.util.Contact;
/*
 * Created on 17 juin 2005
 */

/**
 * @author Emmanuel DURIN
 *
 */
public class ContactPanel extends JPanel {

    private JLabel labelFirstname = new JLabel("Firstname : ");
    private JLabel labelLastname = new JLabel("Lastname : ");
    private JLabel labelEmail = new JLabel("Email : ");
    private JTextField textFirstname = new JTextField(15);
    private JTextField textLastname = new JTextField(15);;
    private JTextField textEmail = new JTextField(15);
        
    private JButton buttonApply = new JButton("Apply");
    private JButton buttonReset = new JButton("Reset");
    
    private JDialog dialog;
    
    private Contact contact;

    public ContactPanel(JDialog d, Contact contact) {
        this.dialog = d;
        this.contact = contact;

        reset();

        setFlowLayout();
        buttonApply.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                applyChanges();
                dialog.dispose();
            }
        });
        
        buttonReset.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                reset();
            }
        });
    }
    
    private void setFlowLayout() {
        setLayout( new FlowLayout() );
        
        add(labelFirstname);	    add(textFirstname);
        add(labelLastname);			add(textLastname);
        add(labelEmail);        	add(textEmail);
        add(buttonApply);           add(buttonReset);
    }    
    
    private void applyChanges() {
        contact.setFirstname(textFirstname.getText( ));
        contact.setLastname(textLastname.getText( ));
        contact.setEmailAddress(textEmail.getText( )); 
    }
    private void reset() {
        textFirstname.setText( contact.getFirstname());
        textLastname.setText( contact.getLastname());
        textEmail.setText( contact.getEmailAddress()); 
    }
}
