package jgui.gui;
import java.awt.*;
import java.io.File;

import javax.swing.*;

import jgui.emailer.util.*;
/*
 * Created on 17 juin 2005
 */

/**
 * @author Emmanuel DURIN
 *
 */
public class ContactPanel extends JPanel {

    private JLabel labelFirstname = new JLabel("Firstname : ");
    private JLabel labelLastname = new JLabel("Lastname : ");
    private JLabel labelEmail = new JLabel("Email : ");
    private JTextField textFirstname = new JTextField(15);
    private JTextField textLastname = new JTextField(15);;
    private JTextField textEmail = new JTextField(15);
        
    private JButton buttonApply = new JButton("Apply");
    private JButton buttonReset = new JButton("Reset");
    
    private JDialog dialog;
    
    private Contact contact;

    public ContactPanel(JDialog d, Contact contact) {
        this.dialog = d;
        this.contact = contact;
        reset();

        setFlowLayout( );

        buttonApply.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                applyChanges();
                dialog.dispose();
            }
        });
        
        buttonReset.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                reset();
            }
        });
    }
    
    private void setFlowLayout() {
        setLayout( new BorderLayout() );
        
        JPanel northPanel = new JPanel( new FlowLayout());
        
        northPanel.add(labelFirstname);	    northPanel.add(textFirstname);
        northPanel.add(labelLastname);		northPanel.add(textLastname);
        northPanel.add(labelEmail);        	northPanel.add(textEmail);
        PictureBean picture = new PictureBean();
        picture.setDirectory(".."+ File.separator + "pictures");
        picture.setImageIcon( new ImageIcon(".." + File.separator +"pictures" + File.separator + "Corinne.jpg"));
        northPanel.add(picture);
        
        JPanel southPanel = new JPanel( new FlowLayout());
        
        southPanel.add(buttonApply);           southPanel.add(buttonReset);
        
        add(northPanel, BorderLayout.CENTER);
        add(southPanel, BorderLayout.SOUTH);
    }  
    
    private void applyChanges() {
        contact.setFirstname(textFirstname.getText( ));
        contact.setLastname(textLastname.getText( ));
        contact.setEmailAddress(textEmail.getText( )); 
    }
    private void reset() {
        textFirstname.setText( contact.getFirstname());
        textLastname.setText( contact.getLastname());
        textEmail.setText( contact.getEmailAddress()); 
    }
}
