/*
 * Created on 24 juin 2005
 */
package jgui.model;

import java.io.*;
import java.io.File;
import java.util.*;
import java.util.Vector;

import javax.swing.AbstractListModel;

import jgui.emailer.util.*;
import jgui.emailer.util.Contact;

/**
 * @author Emmanuel DURIN
 *
 */
public class ContactsModel extends AbstractListModel {

    private Vector contacts = new Vector();
    private File f;


    /* (non-Javadoc)
     * @see javax.swing.ListModel#getSize()
     */
    public int getSize() {
        return contacts.size();
    }

    /* (non-Javadoc)
     * @see javax.swing.ListModel#getElementAt(int)
     */
    public Object getElementAt(int index) {
        return contacts.get(index);
    }

    public void add( Contact c )
    {
        contacts.add(c);
        fireIntervalAdded(this,contacts.size()-1,contacts.size()-1);
    }
    public Object remove(int index) {
        fireIntervalRemoved(this,index, index);
        return contacts.remove(index);
    }
    public boolean remove(Contact c ) {
        int index = contacts.indexOf(c);
        fireIntervalRemoved(this, index, index);        
        return contacts.remove(c);
    }
    
    public void save() throws IOException
    {
        Toolbox.saveVector(contacts, f);
    }
    // les exceptions doivent remonter jusqu' l'IHM
    // car on doit tre capable de les signaler  l'utilisateur
    public void open(File f) throws OptionalDataException, FileNotFoundException, ClassNotFoundException, IOException
    {
        this.f = f;
		Vector v = Toolbox.loadVector( f );

		for (Iterator iter = v.iterator(); iter.hasNext();) {
			add( (Contact)iter.next() );
		}
    }
}
