/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.*;

import jgui.emailer.util.Contact;
import jgui.gui.ContactsFrame;
import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class AddContactAction extends AbstractAction implements Action {

    private ContactsModel model;
    private ContactsFrame frame;
    public AddContactAction( ContactsFrame frame, ContactsModel model)
    {
        this.frame = frame;
        this.model = model;
        putValue(SHORT_DESCRIPTION, "Add Contact");
        putValue(LONG_DESCRIPTION, "Creates a contact.");
        putValue(NAME, "Add Contact");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "add.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_T) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_T, ActionEvent.CTRL_MASK));
    }

    public void actionPerformed(ActionEvent event) {
        model.add( new Contact() );
        frame.addContact();
    }

}
