/*
 * Created on 24 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.io.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.AbstractAction;

import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class SaveAction extends AbstractAction {
    private ContactsModel model;
   
    public SaveAction(ContactsModel model) {
        this.model = model;
        putValue(SHORT_DESCRIPTION, "Save file");
        putValue(LONG_DESCRIPTION, "Save in a file. Ask for a file name if not already saved");
        putValue(NAME, "Save");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "save.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_S) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
    }

    public void actionPerformed(ActionEvent event) {
        try {
            model.save();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
