/*
 * Created on 28 juin 2005
 */
package jgui.gui.locale;

import java.io.*;
import java.util.*;

/**
 * @author Emmanuel DURIN
 *
 */
public class ContactLocale {
    private static Locale localeToSave;
    private static final String FILENAME = "contacts.properties";
    private static ResourceBundle bundle;
    public static void save()
    {
        Properties p = new Properties();
        FileOutputStream f = null;
        try {
            p.put("language", localeToSave.toString());
            f = new FileOutputStream(FILENAME);
            p.store( f ,"prefered language");
        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
        finally{
            if ( f!=null )
                try {
                    f.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
        }    
    }
    public static void load()
    {
        Properties p = new Properties();
        FileInputStream f = null;
        try {
            f = new FileInputStream(FILENAME);
            p.load( f );
            String loc = p.getProperty("language");
            if ( loc != null ){
                localeToSave = new Locale( loc );
                Locale.setDefault( localeToSave );
                
                bundle = PropertyResourceBundle.getBundle(
                        //  resources = comme package = rpertoire
                        // nom du fichier = 
                        // "displaypanel" + "_fr_FR" + ".properties"
                        "resources.displaypanel",localeToSave);
                }else{
                localeToSave = Locale.getDefault();
            }
        }
        catch( FileNotFoundException ex )
        { /* c'est pas grave, on peut dmarrer sans fichier */ }
        catch ( Exception e ) {
            e.printStackTrace();
        }
        finally{
            if ( f!=null )
                try {
                    f.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
        }        
    }

    public static Locale getLocaleToSave() {
        return localeToSave;
    }

    public static void setLocaleToSave(Locale toSave) {
        ContactLocale.localeToSave= toSave;
    }
    /**
     * @return Returns the bundle.
     */
    public static ResourceBundle getBundle() {
        return bundle;
    }
}
