/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.io.IOException;

import javax.swing.*;

import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class ExitAction extends AbstractAction implements Action {

    private JFrame frame;
    private ContactsModel model;
    
    public ExitAction( JFrame frame, ContactsModel model)
    {
        this.model = model;
        this.frame = frame;
        putValue(SHORT_DESCRIPTION, "Exit");
        putValue(LONG_DESCRIPTION, "Exit the Contact application");
        putValue(NAME, "Exit");
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_X) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.ALT_MASK));        
    }
    
    public void actionPerformed(ActionEvent event) {
        
        if ( model.isDirty() ){
            switch ( JOptionPane.showConfirmDialog(frame, "Do you want to save the contact file before exiting ?",
                    "Caution",JOptionPane.YES_NO_CANCEL_OPTION)){
            case JOptionPane.YES_OPTION :
        	    if (model.getFile() == null){
        			JFileChooser saveDialog = new JFileChooser();
        			if ( saveDialog .showSaveDialog(frame) == JFileChooser.APPROVE_OPTION){
        			    model.setFile( saveDialog .getSelectedFile());
        			}
        	    }
//                	    Check the user has selected a file
        	    if ( model.getFile() != null )
                    try {
                        model.save();
                    } catch (IOException e1) {
                        e1.printStackTrace();
                    }                	    
                break;
            case JOptionPane.NO_OPTION :
                break;
            case JOptionPane.CANCEL_OPTION :
                return ;            
            }
        }
        frame.dispose();
    }
}
