/*
 * Created on 28 juin 2005
 */
package jgui.gui;

import java.awt.*;
import java.util.*;

import javax.swing.*;

import jgui.gui.locale.ContactLocale;

/**
 * @author Emmanuel DURIN
 *
 */
public class DisplayPanel extends JPanel implements Appliable {
    private Locale [] locales = new Locale[]{ Locale.FRENCH, Locale.ENGLISH};
    private HashMap name2LAF = new HashMap();
    private HashMap name2Locale = new HashMap();
    private JLabel labelLafSettings = new JLabel(
            ContactLocale.getBundle().getString("lafLabel"));
    private JLabel labelLanguageSettings = new JLabel(
            ContactLocale.getBundle().getString("langLabel"));    
    
    private DefaultComboBoxModel modelLaf = new DefaultComboBoxModel();
    private DefaultComboBoxModel modelLanguage= new DefaultComboBoxModel();
    
    private JComboBox comboLaf= new JComboBox(modelLaf);
    private JComboBox comboLanguage= new JComboBox(modelLanguage);
    private JFrame parent;
    
    public DisplayPanel (JFrame parent )
    {
        this.parent = parent;
        
		for (int i = 0; i < locales.length; i++) {
			modelLanguage.addElement(locales[i].getDisplayName() );
			name2Locale.put( locales[i].getDisplayName(), locales[i] );
        }		
		comboLanguage.setSelectedItem(Locale.getDefault().getDisplayName());
		
		UIManager.LookAndFeelInfo [] lafs = UIManager.getInstalledLookAndFeels();
		for (int i = 0; i < lafs.length; i++) {
		    name2LAF.put(lafs[i].getName(), lafs[i].getClassName());
            modelLaf.addElement(lafs[i].getName());
        }
		comboLaf.setSelectedItem(UIManager.getLookAndFeel().getName());
		
       setLayout(new GridBagLayout() );
       GridBagConstraints gbc = new GridBagConstraints();

       gbc.gridx = 0;
       gbc.gridy = 0;
       gbc.anchor = GridBagConstraints.WEST;
       gbc.ipadx = 10;
       gbc.ipady = 5;
       gbc.insets.top = 0;              
       add( labelLafSettings, gbc );
       
       gbc.insets.top = 0;
       gbc.insets.left = 20;
       gbc.gridy++;
       add( comboLaf,gbc);

       gbc.gridy++;
       gbc.insets.left = 0;       
       gbc.insets.top = 0;              
       add( labelLanguageSettings, gbc );
       
       gbc.insets.top = 0;
       gbc.insets.left = 20;
       gbc.gridy++;
       add( comboLanguage,gbc);       
   }

    public void apply() {
        try {
            String className = (String)name2LAF.get(comboLaf.getSelectedItem());
            //LookAndFeel laf = (LookAndFeel)Class.forName(className).newInstance();
            //UIManager.setLookAndFeel(laf);
            System.out.println(className);
            UIManager.setLookAndFeel(className);
            SwingUtilities.updateComponentTreeUI(parent);
            
            ContactLocale.setLocaleToSave( (Locale)name2Locale.get(comboLanguage.getSelectedItem()));
            ContactLocale.save();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
