/*
 * Created on 28 juin 2005
 */
package jgui.gui;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;

/**
 * @author Emmanuel DURIN
 *
 */
public class SettingsDialog extends JDialog {
    private Appliable[] tabs= new Appliable[2];
    
    public SettingsDialog( JFrame parent )
    {
        super(parent,"Settings",true);
        
        JTabbedPane tabPane = new JTabbedPane();
        getContentPane().add(tabPane, BorderLayout.CENTER);
        
        ComposePanel composePanel = new ComposePanel();
        ConnectionPanel connectionPanel = new ConnectionPanel();
        tabs[0] = composePanel ;
        tabs[1] = connectionPanel;
        
        tabPane.add("Compose",composePanel );
        tabPane.add("Connection",connectionPanel);
        tabPane.add("Display",new JPanel());
        
        tabPane.setBorder( new EmptyBorder(10,10,10,10));
        Box southPanel = Box.createHorizontalBox();
        getContentPane().add(southPanel, BorderLayout.SOUTH);
        
        JButton okButton, cancelButton;

        okButton = new JButton( "OK");
        cancelButton = new JButton( "Cancel");
        
        okButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                for (int i = 0; i < tabs.length; i++) {
                    tabs[i].apply();
                }                
                dispose();
            }
        });
        cancelButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                dispose();
            }
        });
        
        southPanel.add(Box.createHorizontalGlue());
        southPanel.add(okButton);
        southPanel.add(Box.createRigidArea(new Dimension(50,50)));
        southPanel.add(cancelButton);
        southPanel.add(Box.createHorizontalGlue());
        
        pack();
        setResizable(false);
        setVisible(true);
    }
    
}
