package jgui.gui.beans;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class Portrait
  extends
    JLabel
  implements
    MouseListener, Serializable
{
  ImageIcon _imageIcon;
  File _directory;
  File[] _portraits;
  int _currentPortraitIndex;

  public Portrait()
  {
    this.addMouseListener(this);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(120,120);
  }

  public String getDirectory()
  {
    return _directory.getAbsolutePath();
  }

  public void setDirectory(String value)
  {
    _directory = new File(value);
    _portraits = _directory.listFiles();
    _currentPortraitIndex = 0;
  }

  public ImageIcon getImageIcon()
  {
    return _imageIcon;
  }

  public void setImageIcon(ImageIcon value)
  {
    _imageIcon = value;

    if (value != null)
      this.setToolTipText(_imageIcon.getDescription());
    else
      this.setToolTipText("No portrait available");

    this.setIcon(_imageIcon);
  }

  public void actionPerformed(ActionEvent e)
  {
    String filename = this.getNextImageFile();
    if (filename == null)
      this.setImageIcon(null);
    else
      this.setImageIcon(new ImageIcon(filename));
  }

  protected String getNextImageFile()
  {
    if (_portraits == null) return null;
    if (_portraits.length == 0) return null;
    _currentPortraitIndex = (_currentPortraitIndex + 1) % _portraits.length;
    return _portraits[_currentPortraitIndex].getAbsolutePath();
  }


public static void main(String[] args)
  {
    JFrame frame = new JFrame();
   
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    Portrait picture = new Portrait();
    picture.setDirectory(".."+ File.separator + "pictures");
    frame.setContentPane(picture);
    frame.pack();
    frame.setVisible(true);
  }
	public void changeImage()
	{
	    setImageIcon( new ImageIcon ( getNextImageFile()));
	}
	public void mouseClicked(MouseEvent event) {
	    changeImage();
	}
	public void mouseEntered(MouseEvent event) {
	}
	public void mouseExited(MouseEvent event) {
	}
	public void mousePressed(MouseEvent event) {
	}
	public void mouseReleased(MouseEvent event) {
	}

}
