/*
 * Created on 28 juin 2005
 */
package jgui.gui;

import java.awt.BorderLayout;

import javax.swing.*;
import javax.swing.JDialog;

/**
 * @author Emmanuel DURIN
 *
 */
public class SettingsDialog extends JDialog {
    private Appliable[] tabs= new Appliable[3];
    
    public SettingsDialog( JFrame parent)
    {
        super(parent,"Settings",true);
        

        JTabbedPane tabPane = new JTabbedPane();
        getContentPane().add(tabPane, BorderLayout.CENTER);
        
        ComposePanel composePanel = new ComposePanel();
        ConnectionPanel connectionPanel = new ConnectionPanel();
        DisplayPanel displayPanel = new DisplayPanel (parent);
        
        tabs[0] = composePanel ;
        tabs[1] = connectionPanel;
        tabs[2] = displayPanel;
        
        tabPane.add("Compose",composePanel );
        tabPane.add("Connection",connectionPanel);
        tabPane.add("Display", displayPanel  );
        
        JPanel southPanel = new JPanel();
        getContentPane().add(southPanel, BorderLayout.SOUTH);
        
        JButton okButton, cancelButton;

        okButton = new JButton( "OK");
        cancelButton = new JButton( "Cancel");
        
        okButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                for (int i = 0; i < tabs.length; i++) {
                    tabs[i].apply();
                }                
                dispose();
            }
        });
        cancelButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed(  java.awt.event.ActionEvent event)
            {
                dispose();
            }
        });
        
        southPanel.add(okButton);
        southPanel.add(cancelButton);
        
        pack();
        setResizable(false);
        setVisible(true);
    }
    
}
