/*
 * Created on 24 juin 2005
 */
package jgui.model;

import java.io.*;
import java.util.*;

import javax.swing.AbstractListModel;

import jgui.emailer.util.*;

/**
 * @author Emmanuel DURIN
 *
 */
public class ContactsModel extends AbstractListModel /*implements TableModel*/{

    private Vector contacts = new Vector();
    private File f;
    private boolean isDirty;

    /* (non-Javadoc)
     * @see javax.swing.ListModel#getSize()
     */
    public int getSize() {
        return contacts.size();
    }

    /* (non-Javadoc)
     * @see javax.swing.ListModel#getElementAt(int)
     */
    public Object getElementAt(int index) {
        return contacts.get(index);
    }

    public void add( Contact c )
    {
        isDirty = true;        
        contacts.add(c);
        fireIntervalAdded(this,contacts.size()-1,contacts.size()-1);
    }
    public Object remove(int index) {
        isDirty = true;    
        if ( index >= 0 && index < contacts.size() ){
            isDirty = true;
            fireIntervalRemoved(this,index, index);            
        }
        return contacts.remove(index);
    }
    public boolean remove(Contact c ) {
        int index = contacts.indexOf(c);
        if ( index != -1 ){
            isDirty = true;
            fireIntervalRemoved(this, index, index);
        }
        return contacts.remove(c);
    }
    
    public void contactChanged( Contact c )
    {
        int index = contacts.indexOf(c);
        if ( index != -1 ){
            isDirty = true;
            fireContentsChanged(this, index, index);
        }
    }

    public void save() throws IOException
    {
        Toolbox.saveVector(contacts, f);
        isDirty = false;
    }
    
    public void newFile()
    {
        f = null;
        isDirty = false;
        if (contacts != null){
            if ( contacts.size() > 0) 
                fireIntervalRemoved(this,0,contacts.size()-1 );            
	        contacts.clear();
        }
    }
    
    // Les exceptions doivent remonter jusqu' l'IHM
    // car on doit tre capable de les signaler  l'utilisateur
    public void open(File f) throws OptionalDataException, FileNotFoundException, ClassNotFoundException, IOException
    {
        newFile();
        isDirty = false;        
        this.f = f;
		Vector v = Toolbox.loadVector( f );

		for (Iterator iter = v.iterator(); iter.hasNext();) {
			add( (Contact)iter.next() );
		}
    }

    public File getFile() {
        return f;
    }
    public void setFile(File selectedFile) {
        this.f = selectedFile;
    }    
    
    /**
     * @return Returns the isDirty.
     */
    public boolean isDirty() {
        return isDirty;
    }
    /**
     * @param isDirty The isDirty to set.
     */
    public void setDirty(boolean isDirty) {
        this.isDirty = isDirty;
    }
}