/*
 * Created on 29 juin 2005
 */
package jgui.gui.beans;

import java.awt.Image;
import java.beans.*;

import javax.swing.ImageIcon;

/**
 * @author Emmanuel DURIN
 *
 */
public class PortraitBeanInfo extends SimpleBeanInfo {
    
    // all other methods are inherited.
    // introspection does its work
    public Image getIcon(int iconType) {
        switch( iconType ){
 	   		default :
 	   		case ICON_MONO_16x16:
 	   		    return loadImage("beanm1616.gif");
        	case ICON_COLOR_16x16:
        	    return loadImage("beanc1616.gif");
        	case ICON_COLOR_32x32:
        	    return loadImage("beanc3232.gif");
        	case ICON_MONO_32x32:
        	    return loadImage("beanm3232.gif");
        }
    }
//    public static void main( String[] args)
//    {
//        JFrame f = new JFrame();
//        
//        PortraitBeanInfo pbi = new PortraitBeanInfo();
//        Image icon = pbi.getIcon(SimpleBeanInfo.ICON_COLOR_32x32);
//        f.getContentPane().add(
//                new JLabel(
//                        new ImageIcon(
//                        icon
//                        ))
//                        );
//        f.setSize(300,300);
//        f.show();
//    
//    }


    public PropertyDescriptor[] getPropertyDescriptors() {
        PropertyDescriptor[] props = null;
        try {
            props = new PropertyDescriptor[]
            {
                new PropertyDescriptor("path", java.lang.String.class, "getPath", null),
                new PropertyDescriptor("imageIcon", ImageIcon.class, "getImageIcon", null)
            };
            
            props[0].setPropertyEditorClass( PathEditor.class);
        } catch (IntrospectionException e) {
            return super.getPropertyDescriptors();
        }
        return props;
    }
}