/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.event.*;
import java.io.File;

import javax.swing.*;

import jgui.model.ContactsModel;

/**
 * @author Emmanuel DURIN
 *
 */
public class RemoveContactAction extends AbstractAction implements Action {

    private JList contactsList;
    private ContactsModel contactsModel;

    public RemoveContactAction( JList contactsList, ContactsModel contactsModel) {
        this.contactsList = contactsList;
        this.contactsModel = contactsModel;
        putValue(SHORT_DESCRIPTION, "Remove a Contact");
        putValue(LONG_DESCRIPTION, "Removes the selected contact.");
        putValue(NAME, "Remove Contact");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "remove.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_R) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));        
    }
    
    public void actionPerformed(ActionEvent event) {
        int selectedIndex = contactsList.getSelectedIndex(); 
        if ( selectedIndex != -1 )
            contactsModel.remove(selectedIndex);
    }
}
