/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.*;

import jgui.emailer.util.Contact;

/**
 * @author Emmanuel DURIN
 *
 */
public class CopyAction extends AbstractAction implements Action {
    private JFrame frame;
    
    public CopyAction(JFrame frame) {
        this.frame = frame;
        putValue(SHORT_DESCRIPTION, "Copy");
        putValue(NAME, "Copy");        
        putValue(LONG_DESCRIPTION, "Copy and put the content in the clipboard.");
        putValue(SMALL_ICON, new ImageIcon("toolbar" + File.separatorChar + "copy.gif"));
        putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_C) );
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
    }
    public void actionPerformed(ActionEvent event) {
        
        Component c = frame.getFocusOwner();
        
        System.out.println("Copy");
        
        if ( c instanceof JList ){
            JList l = (JList)c;
            Object selectedObject = l.getSelectedValue();
            if ( selectedObject instanceof Contact){
                Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
                
                cb.setContents( new StringSelection(c.toString()), null);
                return;
            }
        }
        else        
            CutCopyPasteHelper.callMethod(frame, "copy");
    }
}