/*
 * Created on 5 sept. 2006
 */
package jgui.gui.datatransfer.dnd;

import java.awt.datatransfer.*;
import java.io.*;

import jgui.emailer.util.Contact;

public class ContactSelection implements Transferable
{
    private Contact contact;
    
    private DataFlavor[] flavors;
    
    public final static DataFlavor javaReferenceFlavor =
        new DataFlavor(
                DataFlavor.javaJVMLocalObjectMimeType,
                "Java Reference");

    public final static DataFlavor serializedFlavor =
        new DataFlavor(Contact.class, "Serialized Java Object");
    
    public ContactSelection(Contact contact)
    {
        this.contact = contact;
        flavors = new DataFlavor[2];
        flavors[0] = DataFlavor.stringFlavor;
        flavors[1] = javaReferenceFlavor;
        //flavors[2] = serializedFlavor;
    }

    public DataFlavor [ ] getTransferDataFlavors( )
    {
        System.out.println("getTransferDataFlavors");
        return flavors; 
    }
    public boolean isDataFlavorSupported(DataFlavor flavor)
    {
        System.out.println("isDataFlavorSupported " + flavor);
        for (int i=0; i<flavors.length; ++i)
            if (flavor.equals(flavors[i]))
                return true;
        return false;
    }

    public Object getTransferData(DataFlavor flavor)
        throws
            UnsupportedFlavorException,
            IOException
    {
        System.out.println("getTransferData for " + flavor);        
        if (isDataFlavorSupported(flavor)) {
            if ( flavor.equals(DataFlavor.stringFlavor))
                return contact.toString();
//            else if ( flavor.equals(serializedFlavor)){
//                ByteArrayOutputStream bos = new ByteArrayOutputStream();
//                ObjectOutputStream oos = new ObjectOutputStream(bos);
//                oos.writeObject(contact);
//                oos.close();
//                byte [] objectArray = bos.toByteArray();
//                
//                return objectArray;//new ObjectInputStream( new ByteArrayInputStream(objectArray));
//                return contact;
//            }
            else
                return contact;
        }
        else throw new UnsupportedFlavorException(flavor);
    }
}