/*
 * Created on 25 juin 2005
 */
package jgui.actions;

import java.awt.*;
import java.lang.reflect.Method;

/**
 * @author Emmanuel DURIN
 *
 */
public class CutCopyPasteHelper {
    public static void callMethod( Frame parentWindow, String methodName)
    {
        // 

        // le JTextField ou la JList perdent le Focus
        // C'est donc pas le bon compopsant qui a le focus au 
        // moment de cette interrogation
   
        // Note : getFocusOwner() est prsente dans la Frame mais pas
        // dans JPanel
        Component c = parentWindow.getFocusOwner();

        /*
        // But de la mnoeuvre introspective suivante :
        //
     	// on voudrait tre capable d'appeler
     	// les mthodes cut, copy paste
     	// Mais ces mthodes n'existent pas dans toutes les
     	// classes de composant
     	Component c = parentWindow.getFocusOwner();
     	// JTextField a cut, copy, paste
     	c.cut();
     	c.copy();
     	c.paste();
     */
        
        Class componentClass = c.getClass();
        
        Method m;
        try {
            m = componentClass.getMethod(methodName, new Class[]{});
            if ( m != null ){
                m.invoke(c, new Object[]{});
            }
        } catch (Exception e) {
            // No method found : normal flow 
        }    
    }

}
