import java.awt.*;
import java.util.*;

import javax.swing.JLabel;
/*
 * Created on 8 fvr. 2006
 */

/**
 * @author Emmanuel DURIN
 *
 */
public class RadarLabel extends JLabel implements PointListener {
    
    private int xCenter, yCenter;
    private Vector points = new Vector();
    public RadarLabel(int x, int y, int width, int height) {
        setBackground(Color.BLACK);
        setOpaque(true);
        setBounds(x,y,width,height);
        xCenter = width / 2;
        yCenter = height / 2;
        Thread t = new Thread( new ThreadMajJFC(this));
        t.start();
    }
    
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        setForeground(Color.GREEN);
        
        // Calendar est mieux que java.util.Date, car localis
        Calendar time = Calendar.getInstance(Locale.FRANCE); 
        long seconds = time.get(Calendar.SECOND);
        
        // On utilise l'objet Graphics (g) pass en paramtre de la fonction
        // paintComponent pour faire des dessins
        
        g.drawLine(xCenter, yCenter, 
                xCenter + (int)(xCenter*Math.cos( seconds*2*Math.PI/15 +Math.PI/2)) , 
                yCenter + (int)(yCenter*Math.sin( seconds*2*Math.PI/15 +Math.PI/2)));
        final int POINTLENGTH = 2;
        synchronized(points){
            for (int i = 0; i < points.size(); i++) {
                Point p = (Point)points.get(i);
                
                g.drawLine(xCenter +p.x, 
                        yCenter +p.y -POINTLENGTH,
                        xCenter +p.x , 
                        yCenter +p.y +POINTLENGTH
                        );
                g.drawLine(xCenter +p.x -POINTLENGTH, 
                        yCenter +p.y ,
                        xCenter +p.x +POINTLENGTH, 
                        yCenter +p.y 
                        );                
            }
        }
    }
    public void addPoint(Point p) {
        synchronized( points){
            points.addElement(p);
        }
    }
    public void removePoint(Point p) {
        synchronized( points){
            points.remove(p);
        }
    }
    public void movePoint(Point p) {}
}
