/*
 * Created on 7 fvr. 2006
 */
package jgui.serialization;

import java.awt.event.*;
import java.awt.event.WindowAdapter;
import java.io.*;

import jgui.gui.ContactsFrame;



/**
 * @author Emmanuel DURIN
 *
 */
public class ContactFrameSerializationManager extends WindowAdapter {
    private static final String fileName = "ihmini.ser";
    
    private ContactsFrame frame;
    
    public ContactFrameSerializationManager(ContactsFrame frame) {
        this.frame = frame;
    }
    public void windowClosing(WindowEvent event) {
        FileOutputStream fos = null;
        ObjectOutputStream oos = null;
        try{
            fos = new FileOutputStream(fileName);
            oos = new ObjectOutputStream(fos);
            oos.writeObject( frame );
        }catch( Exception e ){
            e.printStackTrace();
        }finally{
            if (fos!=null)
                try {
                    fos.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
        }
    }
    
    public static ContactsFrame createContactsFrame() {
        ContactsFrame cf = null;
        FileInputStream fis = null;
        ObjectInputStream ois = null;
        try{
            fis = new FileInputStream(fileName);
            ois = new ObjectInputStream(fis);
            cf = (ContactsFrame)ois.readObject();

            // les listeners ne sont pas serializable 
            // il faut recrer les listeners  la main
            cf.addActions();
        }catch (Exception e) {
            cf = new ContactsFrame();
        }
        finally{
            try{
	            if (fis!=null)
	                fis.close();
            }catch( Exception e ){
                e.printStackTrace();
            }
        }
        return cf;
    }
}