package jgui.emailer.util;

import java.util.*;
import java.io.*;

public class Toolbox
{
  /**
   * Load and return the vector saved in the file in the
   * parameter list. If there is any problem with the file,
   * return an empty vector.
   */
  public static Vector loadVector(File file)
    throws
      FileNotFoundException,
      OptionalDataException,
      ClassNotFoundException,
      IOException
  {
    System.out.println("Loading " + file);

    ObjectInputStream input =
      new ObjectInputStream(new FileInputStream(file));

    Vector vec = (Vector) input.readObject();

    input.close();

    System.out.println("Loaded " + vec + " from " + file);

    return vec;
  }

  /**
   * Save the vector in the file. If the file allready exists,
   * it is replaced by a new one.
   */
  public static void saveVector(Vector vec, File file)
    throws
      IOException
  {
    System.out.println("Saving " + vec + " in " + file);

    ObjectOutputStream output =
      new ObjectOutputStream(new FileOutputStream(file));

    output.writeObject(vec);

    output.close();

    System.out.println(file + " saved");
  }

  public static void generateContactDataFile (File file)
  {
    Vector vector = new Vector();

    Contact contact = new Contact();
    contact.setFirstname("Calvin");
    contact.setLastname("");
    contact.setEmailAddress("");
    vector.addElement(contact);

    contact = new Contact();
    contact.setFirstname("Tintin");
    contact.setLastname("");
    contact.setEmailAddress("");
    vector.addElement(contact);

    contact = new Contact();
    contact.setFirstname("Asterix");
    contact.setLastname("");
    contact.setEmailAddress("");
    vector.addElement(contact);

    contact = new Contact();
    contact.setFirstname("Sam");
    contact.setLastname("Pezzo");
    contact.setEmailAddress("");
    vector.addElement(contact);

    contact = new Contact();
    contact.setFirstname("Duncan");
    contact.setLastname("Idaho");
    contact.setEmailAddress("");
    vector.addElement(contact);

    try
    {
      Toolbox.saveVector(vector, file);
    }
    catch(Exception exc)
    {
      exc.printStackTrace();
    }
  }
}
