import java.awt.Cursor;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import javax.swing.*;

class IconDropTargetListener implements DropTargetListener
{
    JLabel _label;
    boolean _isDragValid;

    public void dragEnter(DropTargetDragEvent evt) {
        checkDrag(evt);}

    public static DataFlavor imageIconFlavor =
        new DataFlavor(ImageIcon.class, "Image Icon Flavor");

        private void checkDrag(DropTargetDragEvent evt)
        {
            DropTarget target = evt.getDropTargetContext().getDropTarget();
            _label = (JLabel) target.getComponent();

            int targetActions = target.getDefaultActions();
            int sourceActions = evt.getSourceActions();
            int userAction = evt.getDropAction();
            
            _isDragValid =
                (userAction & targetActions & sourceActions) != 0
        &&   evt.isDataFlavorSupported(imageIconFlavor);
        if (_isDragValid)
        {
            _label.setBorder(SimpleDnDExample.LOWERED_BORDER);
            evt.acceptDrag(userAction);
        }
        else
        {
            _label.setBorder(SimpleDnDExample.RAISED_BORDER);
            evt.rejectDrag();
        }
    }
        public void dropActionChanged(DropTargetDragEvent evt)
        {
            checkDrag(evt);
            evt.getDropTargetContext().getDropTarget().getComponent().setCursor(new Cursor(Cursor.MOVE_CURSOR));
        }
        public void dragOver(DropTargetDragEvent evt)
        {
            if (_isDragValid) evt.acceptDrag(evt.getDropAction());
            else evt.rejectDrag();
        }
        public void dragExit(DropTargetEvent evt)
        {
            _label.setBorder(SimpleDnDExample.RAISED_BORDER);
        }
        public void drop(DropTargetDropEvent evt)
        {
            if (_isDragValid)
            {
                evt.acceptDrop(evt.getDropAction());

                ImageIcon icon = getImageIcon(evt);
                if (icon != null) _label.setIcon(icon);
                evt.dropComplete(icon != null);
            }
            else {
                evt.rejectDrop();
                evt.dropComplete(false);
            }
        }
        private ImageIcon getImageIcon(DropTargetDropEvent evt)
        {
            try
            {
                Transferable t = evt.getTransferable();
                
                if (evt.isLocalTransfer())
                    return (ImageIcon) t.getTransferData(JavaObject.javaReferenceFlavor);

                else return (ImageIcon) t.getTransferData(imageIconFlavor);
            }
            catch (Exception exc)
            {
                return null;
            }
        }

    }
