import java.awt.datatransfer.*;
import java.io.*;

public class JavaObject implements Transferable
{
    Object _obj;
    
    DataFlavor[] _flavors;
    
    public static DataFlavor javaReferenceFlavor =
    new DataFlavor(
        DataFlavor.javaJVMLocalObjectMimeType,
        "Java Reference");
    public JavaObject(Object obj)
    {
        _obj = obj;
        
        if (obj instanceof Serializable)
        {
            _flavors = new DataFlavor[2];
            _flavors[0] = javaReferenceFlavor;
            _flavors[1] = new DataFlavor(obj.getClass(), "Serialized Java Object");
        }
        else
        {
            _flavors = new DataFlavor[1];
            _flavors[0] = javaReferenceFlavor;
        }
    }

    public DataFlavor [ ] getTransferDataFlavors( ) { return _flavors; }
    public boolean isDataFlavorSupported(DataFlavor flavor)
    {
        for (int i=0; i<_flavors.length; ++i)
            if (flavor.equals(_flavors[i]))
                return true;
        
        return false;
    }

    public Object getTransferData(DataFlavor flavor)
        throws
            UnsupportedFlavorException,
            IOException
    {
        if (isDataFlavorSupported(flavor)) return _obj;
        else throw new UnsupportedFlavorException(flavor);
    }

}
