import java.awt.FlowLayout;
import java.awt.dnd.*;

import javax.swing.*;
import javax.swing.border.*;

public class SimpleDnDExample extends JFrame
{
    public static ImageIcon EMPTY_ICON = new ImageIcon("empty.gif");
    public static Border RAISED_BORDER = new BevelBorder(BevelBorder.RAISED);
    public static Border LOWERED_BORDER = new BevelBorder(BevelBorder.LOWERED);

    public SimpleDnDExample()
    {
        JLabel source = new JLabel(new ImageIcon("Manon.gif"));
        JLabel target = new JLabel(EMPTY_ICON);

        source.setBorder(RAISED_BORDER);
        target.setBorder(RAISED_BORDER);

        getContentPane().setLayout(new FlowLayout());
        getContentPane().add(source);
        getContentPane().add(target);
        
        initDragSource(source);
        initDropTarget(target);
     
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        pack();
    }
    private void initDragSource(JLabel source)
    {
        DragSource dragSource = DragSource.getDefaultDragSource();

        dragSource.createDefaultDragGestureRecognizer(
            source,                 // associated component
            DnDConstants.ACTION_COPY_OR_MOVE ,  // accepted drag semantics
            new IconGestureListener());         // gesture listener
    }

    private void initDropTarget(JLabel target)
    {
        new DropTarget (
        target,
        DnDConstants.ACTION_COPY_OR_MOVE,
        new IconDropTargetListener(),
        true);
    }


    public static void main(String[] args)
    {
        SimpleDnDExample example = new SimpleDnDExample();
        example.setVisible(true);
    }
}
